<?php
namespace Coucou;

use Coucou\Model\Coucou;
use Coucou\Model\CoucouTable;
use Zend\Db\ResultSet\ResultSet;
use Zend\Db\TableGateway\TableGateway;

class Module
{
    public function getAutoloaderConfig()
    {
        return array(
            'Zend\Loader\ClassMapAutoloader' => array(
                __DIR__ . '/autoload_classmap.php',
            ),
            'Zend\Loader\StandardAutoloader' => array(
                'namespaces' => array(
                    __NAMESPACE__ => __DIR__ . '/src/' . __NAMESPACE__,
                ),
            ),
        );
    }

    public function getConfig()
    {
        return include __DIR__ . '/config/module.config.php';
    }

    public function getServiceConfig()
    {
        return array(
            'factories' => array(
                'Coucou\Model\CoucouTable' =>  function($sm) {
                    $tableGateway = $sm->get('CoucouTableGateway');
                    $table = new CoucouTable($tableGateway);
                    return $table;
                },
                'CoucouTableGateway' => function ($sm) {
                    $dbAdapter = $sm->get('Zend\Db\Adapter\Adapter');
                    $resultSetPrototype = new ResultSet();
                    $resultSetPrototype->setArrayObjectPrototype(new Coucou());
                    return new TableGateway('coucou', $dbAdapter, null, $resultSetPrototype);
                },
            ),
        );
    }

}

